Index: src/main/java/edu/gjoko/schedlr/config/AppConfig.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/config/AppConfig.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/config/AppConfig.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -15,8 +15,4 @@
     }
 
-    @Bean
-    public AuthenticationSuccessHandler appAuthenticationSuccessHandler() {
-        return new AppAuthenticationSuccessHandler();
-    }
 
     @Bean
Index: src/main/java/edu/gjoko/schedlr/config/AppFilter.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/config/AppFilter.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/config/AppFilter.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -64,5 +64,9 @@
                             break;
                         case "CUSTOMER":
-                            page = "/homepage";
+                            if ("/customer_admin".equals(httpServletRequest.getRequestURI())) {
+                                page = "/customer_admin";
+                            } else {
+                                page = "/homepage";
+                            }
                             break;
                         case "BUSINESS_OWNER":
Index: src/main/java/edu/gjoko/schedlr/config/AppSecurityConfig.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/config/AppSecurityConfig.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/config/AppSecurityConfig.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -32,6 +32,4 @@
     private final BCryptPasswordEncoder passwordEncoder;
 
-    private final AuthenticationSuccessHandler authenticationSuccessHandler;
-
     private final AuthenticationFailureHandler authenticationFailureHandler;
 
@@ -57,7 +55,6 @@
                 .loginPage("/login")
                 .loginProcessingUrl("/login")
-                .successHandler(authenticationSuccessHandler)
                 .failureHandler(authenticationFailureHandler)
-                .defaultSuccessUrl("/homepage")
+                .defaultSuccessUrl("/login")
                 .and()
                 .logout(logout -> logout
Index: src/main/java/edu/gjoko/schedlr/config/ExceptionHandlerAdvice.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/config/ExceptionHandlerAdvice.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/config/ExceptionHandlerAdvice.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,19 @@
+package edu.gjoko.schedlr.config;
+
+import edu.gjoko.schedlr.exceptions.BlockingTimeException;
+import org.springframework.http.HttpHeaders;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.ControllerAdvice;
+import org.springframework.web.bind.annotation.ExceptionHandler;
+import org.springframework.web.context.request.WebRequest;
+import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;
+
+@ControllerAdvice
+public class ExceptionHandlerAdvice extends ResponseEntityExceptionHandler {
+
+    @ExceptionHandler(value = BlockingTimeException.class)
+    protected ResponseEntity<Object> handleConflict(RuntimeException ex, WebRequest request) {
+        return handleExceptionInternal(ex, ex.getMessage(), new HttpHeaders(), HttpStatus.CONFLICT, request);
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/config/MvcConfig.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/config/MvcConfig.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/config/MvcConfig.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -16,4 +16,5 @@
         registry.addViewController("/admin").setViewName("admin");
         registry.addViewController("/business_admin").setViewName("business_admin");
+        registry.addViewController("/customer_admin").setViewName("customer_admin");
     }
 }
Index: src/main/java/edu/gjoko/schedlr/controllers/AdministrationController.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/AdministrationController.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/AdministrationController.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,30 @@
+package edu.gjoko.schedlr.controllers;
+
+import org.springframework.security.core.Authentication;
+import org.springframework.security.core.context.SecurityContextHolder;
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.GetMapping;
+
+import javax.servlet.http.HttpServletRequest;
+
+@Controller
+public class AdministrationController {
+
+    @GetMapping(path = "/admin")
+    public String getAdminPageTemplate(Model model) {
+        return "admin";
+    }
+
+    @GetMapping(path = "/business_admin")
+    public String getBusinessAdminPageTemplate(Model model) {
+        return "business_admin";
+    }
+
+    @GetMapping(path = "/customer_admin")
+    public String getCustomerAdminPageTemplate(Model model) {
+        return "customer_admin";
+    }
+
+
+}
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/AppointmentApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/AppointmentApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/AppointmentApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,59 @@
+package edu.gjoko.schedlr.controllers.rest;
+
+import edu.gjoko.schedlr.dto.AppointmentDto;
+import edu.gjoko.schedlr.dto.AppointmentInfoDto;
+import edu.gjoko.schedlr.entity.Appointment;
+import edu.gjoko.schedlr.entity.Stakeholder;
+import edu.gjoko.schedlr.mappers.AppointmentDtoMapper;
+import edu.gjoko.schedlr.services.AppointmentsService;
+import lombok.AllArgsConstructor;
+import org.springframework.web.bind.annotation.*;
+
+import javax.security.sasl.AuthenticationException;
+import javax.servlet.http.HttpServletRequest;
+import java.time.LocalDateTime;
+import java.util.List;
+import java.util.stream.Collectors;
+
+@RestController
+@RequestMapping("api/appointment")
+@AllArgsConstructor
+public class AppointmentApi {
+
+    private final AppointmentsService appointmentsService;
+    private final AppointmentDtoMapper appointmentsMapper;
+
+    @PostMapping
+    public void getBusinessTypes(@RequestBody Appointment appointment, HttpServletRequest request) {
+        Long customerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        Stakeholder customer = new Stakeholder();
+        customer.setId(customerId);
+        appointment.setCustomer(customer);
+        appointmentsService.saveAppointment(appointment);
+    }
+
+    @GetMapping(path = "/business/{businessId}")
+    public List<AppointmentDto> getAppointmentsByBusiness(@PathVariable("businessId") Long businessId) {
+        return appointmentsService.getActiveAppointmentsByBusiness(businessId).stream()
+                .map(appointmentsMapper::appointmentToAppointmentDto)
+                .collect(Collectors.toList());
+    }
+
+    @GetMapping(path = "/future/me")
+    public List<AppointmentInfoDto> getFutureAppointmentsInfoList(HttpServletRequest request) {
+        Long businessOwnerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        return appointmentsService.getFutureAppointmentInfoList(businessOwnerId);
+    }
+
+    @GetMapping(path = "/past/me")
+    public List<AppointmentInfoDto> getPastAppointmentsInfoList(HttpServletRequest request) {
+        Long stakeholderId = (long) request.getSession(true).getAttribute("stakeholderId");
+        return appointmentsService.getPastAppointmentInfoList(stakeholderId);
+    }
+
+    @DeleteMapping("/{appointmentId}")
+    public void cancelAppointment(@PathVariable("appointmentId") Long appointmentId, HttpServletRequest request) throws AuthenticationException {
+        Long stakeholderId = (long) request.getSession(true).getAttribute("stakeholderId");
+        appointmentsService.deleteAppointment(appointmentId, stakeholderId);
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/BusinessApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/BusinessApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/BusinessApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,43 @@
+package edu.gjoko.schedlr.controllers.rest;
+
+import edu.gjoko.schedlr.entity.Business;
+import edu.gjoko.schedlr.services.BusinessService;
+import lombok.AllArgsConstructor;
+import org.springframework.web.bind.annotation.*;
+
+import javax.servlet.http.HttpServletRequest;
+import java.util.List;
+
+@RestController
+@RequestMapping("api/business")
+@AllArgsConstructor
+public class BusinessApi {
+
+    private final BusinessService businessService;
+
+    @PostMapping
+    public void saveBusiness(@RequestBody Business business) {
+        businessService.saveBusiness(business);
+    }
+
+    @GetMapping
+    public List<Business> findAll() {
+        return businessService.findAll();
+    }
+
+    @PatchMapping
+    public void updateBusinesses(@RequestBody List<Business> businessList) {
+        businessService.updateBusinesses(businessList);
+    }
+
+    @GetMapping(path = "/me")
+    public Business getPersonalInfo(HttpServletRequest request) {
+        Long businessOwnerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        return businessService.findByOwner(businessOwnerId);
+    }
+
+    @GetMapping(path = "/{businessTypeId}")
+    public List<Business> getBusinessesByBusinessType(@PathVariable("businessTypeId") Long id) {
+        return businessService.findByBusinessTypeAndActiveStatus(id);
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/CustomerApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/CustomerApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/CustomerApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,29 @@
+package edu.gjoko.schedlr.controllers.rest;
+
+import edu.gjoko.schedlr.entity.Business;
+import edu.gjoko.schedlr.entity.Stakeholder;
+import edu.gjoko.schedlr.services.StakeholderService;
+import lombok.AllArgsConstructor;
+import org.springframework.web.bind.annotation.*;
+
+import javax.servlet.http.HttpServletRequest;
+import java.util.List;
+
+@RestController
+@RequestMapping("api/customer")
+@AllArgsConstructor
+public class CustomerApi {
+
+    private final StakeholderService stakeholderService;
+
+    @GetMapping(path = "/me")
+    public Stakeholder getCustomerInfo(HttpServletRequest request) {
+        Long customerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        return stakeholderService.findById(customerId);
+    }
+
+    @PatchMapping
+    public void updateCustomer(@RequestBody Stakeholder stakeholder) {
+        stakeholderService.saveOrUpdateStakeholder(stakeholder);
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/NomenclatureApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/NomenclatureApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/NomenclatureApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,22 @@
+package edu.gjoko.schedlr.controllers.rest;
+
+import edu.gjoko.schedlr.entity.BusinessType;
+import edu.gjoko.schedlr.services.NomenclaturesService;
+import lombok.AllArgsConstructor;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+import org.springframework.web.bind.annotation.RestController;
+
+import java.util.List;
+
+@RestController
+@RequestMapping("api/nomenclatures")
+@AllArgsConstructor
+public class NomenclatureApi {
+
+    private final NomenclaturesService nomenclaturesService;
+    @GetMapping( "/businessTypes")
+    public List<BusinessType> getBusinessTypes() {
+        return nomenclaturesService.getBusinessTypes();
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/ReviewApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/ReviewApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/ReviewApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,44 @@
+package edu.gjoko.schedlr.controllers.rest;
+
+import edu.gjoko.schedlr.dto.ReviewDto;
+import edu.gjoko.schedlr.entity.Review;
+import edu.gjoko.schedlr.entity.Stakeholder;
+import edu.gjoko.schedlr.mappers.ReviewDtoMapper;
+import edu.gjoko.schedlr.services.ReviewService;
+import lombok.AllArgsConstructor;
+import org.springframework.web.bind.annotation.*;
+
+import javax.servlet.http.HttpServletRequest;
+import java.util.List;
+
+@RestController
+@RequestMapping("api/review")
+@AllArgsConstructor
+public class ReviewApi {
+
+    private final ReviewService reviewService;
+    private final ReviewDtoMapper reviewDtoMapper;
+
+    @PostMapping
+    public void getBusinessTypes(@RequestBody Review review, HttpServletRequest request) {
+        Long customerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        Stakeholder customer = new Stakeholder();
+        customer.setId(customerId);
+        reviewService.save(review, customerId);
+    }
+
+    @GetMapping(path = "/me")
+    public List<ReviewDto> getReviews(HttpServletRequest request) {
+        Long customerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        return reviewService.getReviewsByCustomerId(customerId).stream()
+                .map(reviewDtoMapper::mapToReviewDto)
+                .toList();
+    }
+
+    @GetMapping(path = "/{serviceId}")
+    public List<ReviewDto> getReviewsForService(@PathVariable("serviceId") Long serviceId) {
+        return reviewService.getReviewsByServiceId(serviceId).stream()
+                .map(reviewDtoMapper::mapToReviewDto)
+                .toList();
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/UserApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/UserApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/UserApi.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,19 @@
+package edu.gjoko.schedlr.controllers.rest;
+
+import lombok.AllArgsConstructor;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+import org.springframework.web.bind.annotation.RestController;
+
+import javax.servlet.http.HttpServletRequest;
+
+@RestController
+@RequestMapping("api/user")
+@AllArgsConstructor
+public class UserApi {
+
+    @GetMapping(path = "/me")
+    public boolean findAll(HttpServletRequest request) {
+        return request.getSession(true).getAttribute("stakeholderId") != null;
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/dto/AppointmentDto.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/dto/AppointmentDto.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/dto/AppointmentDto.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,17 @@
+package edu.gjoko.schedlr.dto;
+
+import lombok.*;
+
+import java.time.LocalDateTime;
+
+@Getter
+@Setter
+@NoArgsConstructor
+@AllArgsConstructor
+@Builder
+public class AppointmentDto {
+
+    private String title;
+    private LocalDateTime startTime;
+    private LocalDateTime endTime;
+}
Index: src/main/java/edu/gjoko/schedlr/dto/AppointmentInfoDto.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/dto/AppointmentInfoDto.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/dto/AppointmentInfoDto.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,18 @@
+package edu.gjoko.schedlr.dto;
+
+import lombok.*;
+
+@Data
+@NoArgsConstructor
+@AllArgsConstructor
+@Builder
+public class AppointmentInfoDto {
+
+    private Long appointmentId;
+    private String fullName;
+    private String email;
+    private String phoneNumber;
+    private String timePeriod;
+    private String serviceName;
+    private String status;
+}
Index: src/main/java/edu/gjoko/schedlr/dto/ReviewDto.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/dto/ReviewDto.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/dto/ReviewDto.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,20 @@
+package edu.gjoko.schedlr.dto;
+
+import lombok.*;
+
+import java.time.LocalDateTime;
+
+@Getter
+@Setter
+@NoArgsConstructor
+@AllArgsConstructor
+@Builder
+public class ReviewDto {
+
+    private String customerName;
+    private String businessName;
+    private String serviceName;
+    private Long rating;
+    private String comment;
+    private LocalDateTime created;
+}
Index: src/main/java/edu/gjoko/schedlr/entity/Appointment.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/Appointment.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/entity/Appointment.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -1,8 +1,6 @@
 package edu.gjoko.schedlr.entity;
 
-import lombok.AllArgsConstructor;
-import lombok.Getter;
-import lombok.NoArgsConstructor;
-import lombok.Setter;
+import com.fasterxml.jackson.annotation.JsonBackReference;
+import lombok.*;
 import org.springframework.data.annotation.LastModifiedDate;
 import org.springframework.data.jpa.domain.support.AuditingEntityListener;
@@ -14,6 +12,5 @@
 @EntityListeners(AuditingEntityListener.class)
 @Table(name = "appointment")
-@Getter
-@Setter
+@Data
 @NoArgsConstructor
 @AllArgsConstructor
@@ -30,15 +27,17 @@
     private LocalDateTime endTime;
 
-    @OneToOne
-    @JoinColumn(name = "customer_id", referencedColumnName = "id")
+    @ManyToOne
+    @JoinColumn(name = "stakeholder_id")
+    @JsonBackReference(value = "customerAppointments")
     private Stakeholder customer;
 
     @ManyToOne
-    @JoinColumn(name = "business_id")
-    private Business business;
+    @JoinColumn(name = "service_id")
+    @JsonBackReference(value = "serviceAppointments")
+    private Service service;
 
-    @ManyToOne
-    @JoinColumn(name = "service_id")
-    private Service service;
+    @Column(name = "appointment_status", length = 32, columnDefinition = "varchar(32) default 'NEW'")
+    @Enumerated(EnumType.STRING)
+    private AppointmentStatus appointmentStatus = AppointmentStatus.NEW;
 
     @Column(name = "created")
@@ -49,3 +48,8 @@
     @LastModifiedDate
     private LocalDateTime modified;
+
+    public String getTimePeriod() {
+        return startTime + " - " + endTime;
+    }
+
 }
Index: src/main/java/edu/gjoko/schedlr/entity/AppointmentStatus.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/AppointmentStatus.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/entity/AppointmentStatus.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,8 @@
+package edu.gjoko.schedlr.entity;
+
+public enum AppointmentStatus {
+    NEW,
+    CANCELLED_BY_CUSTOMER,
+    CANCELLED_BY_BUSINESS_OWNER,
+    FINISHED_AND_REVIEWED_BY_USER;
+}
Index: src/main/java/edu/gjoko/schedlr/entity/Business.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/Business.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/entity/Business.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -37,5 +37,5 @@
     private BusinessType businessType;
 
-    @ManyToOne()
+    @OneToOne(cascade = CascadeType.PERSIST)
     @JoinColumn(name = "owner_id", referencedColumnName = "id", nullable = false)
     @JsonProperty("owner")
@@ -43,5 +43,5 @@
 
     @OneToMany(mappedBy = "business", cascade = CascadeType.PERSIST)
-    @JsonManagedReference
+    @JsonManagedReference(value = "services")
     private List<Service> services;
 
Index: src/main/java/edu/gjoko/schedlr/entity/Review.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/Review.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/entity/Review.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,46 @@
+package edu.gjoko.schedlr.entity;
+
+import com.fasterxml.jackson.annotation.JsonBackReference;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import lombok.AllArgsConstructor;
+import lombok.Getter;
+import lombok.NoArgsConstructor;
+import lombok.Setter;
+import org.springframework.data.annotation.LastModifiedDate;
+import org.springframework.data.jpa.domain.support.AuditingEntityListener;
+
+import javax.persistence.*;
+import java.time.LocalDateTime;
+
+@Entity
+@EntityListeners(AuditingEntityListener.class)
+@Table(name = "review")
+@Getter
+@Setter
+@NoArgsConstructor
+@AllArgsConstructor
+public class Review {
+
+    @Id
+    @GeneratedValue(strategy = GenerationType.SEQUENCE)
+    private Long id;
+
+    @Column(name = "rating")
+    private Integer rating;
+
+    @Column(name = "comment")
+    private String comment;
+
+    @OneToOne
+    @JoinColumn(name = "appointment_id", referencedColumnName = "id")
+    @JsonProperty("appointment")
+    private Appointment appointment;
+
+    @Column(name = "created")
+    @LastModifiedDate
+    private LocalDateTime created;
+
+    @Column(name = "modified")
+    @LastModifiedDate
+    private LocalDateTime modified;
+}
Index: src/main/java/edu/gjoko/schedlr/entity/Service.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/Service.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/entity/Service.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -3,4 +3,5 @@
 import com.fasterxml.jackson.annotation.JsonBackReference;
 import com.fasterxml.jackson.annotation.JsonIgnore;
+import com.fasterxml.jackson.annotation.JsonManagedReference;
 import lombok.AllArgsConstructor;
 import lombok.Getter;
@@ -13,4 +14,5 @@
 import javax.persistence.*;
 import java.time.LocalDateTime;
+import java.util.List;
 
 @Entity
@@ -33,5 +35,11 @@
     private Integer price;
 
-    @OneToOne(cascade = CascadeType.PERSIST)
+    @Column(name = "cumulated_rating")
+    private Float rating = 0.0f;
+
+    @Column(name = "reviews_count")
+    private Integer reviewsCount = 0;
+
+    @OneToOne(cascade = CascadeType.MERGE)
     @JoinColumn(name = "service_type_id", referencedColumnName = "id")
     private ServiceType serviceType;
@@ -39,6 +47,10 @@
     @ManyToOne
     @JoinColumn(name = "business_id")
-    @JsonBackReference
+    @JsonBackReference(value = "services")
     private Business business;
+
+    @OneToMany(mappedBy="service")
+    @JsonManagedReference(value = "serviceAppointments")
+    private List<Appointment> appointments;
 
     @Column(name = "created")
Index: src/main/java/edu/gjoko/schedlr/entity/Stakeholder.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/Stakeholder.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/entity/Stakeholder.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -2,4 +2,5 @@
 
 import com.fasterxml.jackson.annotation.JsonIgnore;
+import com.fasterxml.jackson.annotation.JsonManagedReference;
 import lombok.AllArgsConstructor;
 import lombok.Getter;
@@ -12,4 +13,5 @@
 import javax.persistence.*;
 import java.time.LocalDateTime;
+import java.util.List;
 
 @Entity
@@ -39,4 +41,7 @@
     private String email;
 
+    @Column(name = "phone_number")
+    private String phoneNumber;
+
     @Column(name = "username")
     private String username;
@@ -44,4 +49,8 @@
     @Column(name = "password")
     private String password;
+
+    @OneToMany(mappedBy = "customer")
+    @JsonManagedReference(value = "customerAppointments")
+    private List<Appointment> appointments;
 
     @Column(name = "created")
@@ -54,3 +63,7 @@
     @JsonIgnore
     private LocalDateTime modified;
+
+    public String getFullName() {
+        return firstName + " " + lastName;
+    }
 }
Index: src/main/java/edu/gjoko/schedlr/exceptions/BlockingTimeException.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/exceptions/BlockingTimeException.java	(revision 950fa0d7a6b439770e79c885947e9b7d6058b424)
+++ src/main/java/edu/gjoko/schedlr/exceptions/BlockingTimeException.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -3,5 +3,5 @@
 public class BlockingTimeException extends RuntimeException {
 
-    public static final String MESSAGE = "The selected dates are overlapping with another appointment";
+    public static final String MESSAGE = "Error! The selected dates are overlapping with another appointment.";
     public BlockingTimeException() {
         super(MESSAGE);
Index: src/main/java/edu/gjoko/schedlr/mappers/AppointmentDtoMapper.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/mappers/AppointmentDtoMapper.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/mappers/AppointmentDtoMapper.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,25 @@
+package edu.gjoko.schedlr.mappers;
+
+import edu.gjoko.schedlr.dto.AppointmentDto;
+import edu.gjoko.schedlr.entity.Appointment;
+import org.modelmapper.Condition;
+import org.modelmapper.ModelMapper;
+import org.modelmapper.TypeMap;
+import org.modelmapper.config.Configuration;
+import org.springframework.stereotype.Service;
+
+@Service
+public class AppointmentDtoMapper extends ModelMapper {
+
+    public AppointmentDtoMapper() {
+        this.getConfiguration().setFieldMatchingEnabled(true).setFieldAccessLevel(Configuration.AccessLevel.PRIVATE);
+        TypeMap<Appointment, AppointmentDto> propertyMapper = this.createTypeMap(Appointment.class, AppointmentDto.class);
+        Condition<String, String> hasTitle = ctx -> ctx.getSource() != null;
+        propertyMapper.addMappings(
+                mapper -> mapper.when(hasTitle).map(appointment -> appointment.getService().getServiceType().getName(), AppointmentDto::setTitle)
+        );
+    }
+    public AppointmentDto appointmentToAppointmentDto(Appointment appointment) {
+        return this.map(appointment, AppointmentDto.class);
+    }
+}
Index: src/main/java/edu/gjoko/schedlr/mappers/AppointmentInfoDtoBusinessMapper.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/mappers/AppointmentInfoDtoBusinessMapper.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
+++ src/main/java/edu/gjoko/schedlr/mappers/AppointmentInfoDtoBusinessMapper.java	(revision 77205be723c8b2ffd1ee5618a05e1d12b1cee44a)
@@ -0,0 +1,32 @@
+package edu.gjoko.schedlr.mappers;
+
+import edu.gjoko.schedlr.dto.AppointmentInfoDto;
+import edu.gjoko.schedlr.entity.Appointment;
+import org.modelmapper.ModelMapper;
+import org.modelmapper.TypeMap;
+import org.modelmapper.config.Configuration;
+import org.springframework.stereotype.Service;
+
+@Service
+public class AppointmentInfoDtoBusinessMapper extends ModelMapper {
+
+    public AppointmentInfoDtoBusinessMapper() {
+        this.getConfiguration().setFieldMatchingEnabled(true).setFieldAccessLevel(Configuration.AccessLevel.PRIVATE);
+        TypeMap<Appointment, AppointmentInfoDto> propertyMapper = this.createTypeMap(Appointment.class, AppointmentInfoDto.class);
+        propertyMapper.addMappings(
+                mapper -> {
+                    mapper.map(Appointment::getId, AppointmentInfoDto::setAppointmentId);
+                    mapper.map(appointment -> appointment.getCustomer().getFullName(), AppointmentInfoDto::setFullName);
+                    mapper.map(appointment -> appointment.getCustomer().getEmail(), AppointmentInfoDto::setEmail);
+                    mapper.map(appointment -> appointment.getCustomer().getPhoneNumber(),AppointmentInfoDto::setPhoneNumber);
+                    mapper.map(Appointment::getTimePeriod, AppointmentInfoDto::setTimePeriod);
+                    mapper.map(appointment -> appointment.getService().getServiceType().getName(), AppointmentInfoDto::setServiceName);
+                    mapper.map(Appointment::getAppointmentStatus, AppointmentInfoDto::setStatus);
+                }
+        );
+    }
+
+    public AppointmentInfoDto appointmentToAppointmentInfoDto(Appointment appointment) {
+        return this.map(appointment, AppointmentInfoDto.class);
+    }
+}
